<* +m2extensions *>
MODULE test;

IMPORT gr:=Graphics, Strings;
FROM Printf IMPORT printf, sprintf;

PROCEDURE lines;
  VAR i,k,w,h,col: INTEGER;
      inp: gr.Input;
BEGIN
  w:=gr.GetW();
  h:=gr.GetH();
  col:=16;
  FOR k:=1 TO 8*8*8 DO
    IF gr.PeekInput(inp) & (inp.event=gr.keyDown) & (inp.key=gr.KRETURN) THEN
      printf("test interupted\n");
      RETURN
    END;
    FOR i:=0 TO w BY 5 DO
      gr.SolidLine(i,0,w-i,h,1,col);
      col:=(col+32+32*256) MOD (256*256*256);
    END;
  END;
END lines;

PROCEDURE inputTest;

  TYPE BNAMES = ARRAY gr.Button OF ARRAY [0..11] OF CHAR;

  CONST s0="       ";
        s1="   ";
	bnames = BNAMES{ "mouseLeft","mouseRight","mouseMiddle",
	                  "shift","control","alt" };
	
  VAR i: gr.Input;
      x,y,w,h,fh: INTEGER;

  PROCEDURE calc;
  BEGIN
    gr.StringSize(s0,w,fh);
    w:=w+20;
    h:=fh*4+10;
    x:=(gr.GetW()-w) DIV 2;
    y:=(gr.GetH()-h) DIV 2;
    gr.SetSolidPen(2,827342H);
    gr.SetBrush(gr.bSolid,0A59A74H);
  END calc;

  PROCEDURE frame;
  BEGIN
    gr.Rectangle(x,y,w,h);
    gr.WriteString(x+5,y,s0);
    gr.WriteString(x+5,y+fh,s1);
  END frame;

  PROCEDURE visset(set: gr.Buttons; VAR s: ARRAY OF CHAR);
    VAR flag: BOOLEAN;
  BEGIN
    s[0]:="{"; s[1]:=0C;flag:=FALSE;
    IF gr.mouseLeft IN set THEN
      Strings.Append("mouseLeft",s); flag:=TRUE
    END;
    IF gr.mouseRight IN set THEN
      IF flag THEN Strings.Append(",",s) END;
      Strings.Append("mouseRight",s); flag:=TRUE
    END;
    IF gr.mouseMiddle IN set THEN
      IF flag THEN Strings.Append(",",s) END;
      Strings.Append("mouseMiddle",s); flag:=TRUE
    END;
    IF gr.shift IN set THEN
      IF flag THEN Strings.Append(",",s) END;
      Strings.Append("shift",s); flag:=TRUE
    END;
    IF gr.control IN set THEN
      IF flag THEN Strings.Append(",",s) END;
      Strings.Append("control",s); flag:=TRUE
    END;
    IF gr.alt IN set THEN
      IF flag THEN Strings.Append(",",s) END;
      Strings.Append("alt",s); flag:=TRUE
    END;
    Strings.Append("}",s);
  END visset;

  PROCEDURE vis(VAR i: gr.Input);
    VAR msg,set: ARRAY [0..63] OF CHAR;
  BEGIN
(*
    event: Event;
    x,y: INTEGER;   (* mouse coordinates in "picture", not in window *)
    state: Buttons;
    button: Button; (* for mouse event - mouseLeft|mouseRigt|mouseMiddle *)
    key: INTEGER;   (* for keyboard event - the pressed/releasded key code *)

    mouseDown mouseLeft (153,155)
    {shift,alt}

    keyUp 0045H
    {control,alt}
*)
    visset(i.state,set);
    CASE i.event OF
      |gr.keyUp:
          sprintf(msg,"keyUp, %04xH",i.key);
      |gr.keyDown:
          sprintf(msg,"keyDown, %04xH",i.key);
      |gr.mouseUp:
          sprintf(msg,"mouseUp, %s (%03d,%03d)",bnames[i.button],i.x,i.y);
      |gr.mouseDown:
          sprintf(msg,"mouseDown, %s (%03d,%03d)",bnames[i.button],i.x,i.y);
      |gr.mouseDblClick:
          sprintf(msg,"mouseDblClick, %s (%03d,%03d)",bnames[i.button],i.x,i.y);
    END;
    frame;
    gr.WriteString(x+5,y+fh*2,msg);
    gr.WriteString(x+5,y+fh*3,set);
  END vis;

BEGIN
  gr.FilledRect(0,0,gr.GetW(),gr.GetH(),0FFFFFFH);
  calc; frame;
  REPEAT
    gr.ReadInput(i);
    vis(i);
  UNTIL i.event=gr.mouseDblClick;
  gr.FilledRect(0,0,gr.GetW(),gr.GetH(),0FFFFFFH);
END inputTest;

BEGIN
  printf("starting graphics...\n");
  gr.OpenGraphics;

  gr.WriteString(100,100,"  ");
  gr.SetFont(gr.arial);
  gr.WriteString(100,130,"  ");
  gr.SetFont(gr.courier);
  gr.WriteString(100,160,"  ");
  gr.SetFont(gr.times);
  gr.WriteString(100,190,"  ");

  gr.SetWindowTitle("   ...");
    gr.WaitForClick();
  gr.SetWindowTitle("");

  inputTest;

  gr.SetSolidPen(3,gr.RGB(128,128,128));
  gr.SetBrush(gr.bSolid,gr.RGB(255,0,0));
  gr.Ellipse(10,10,150,150);
  gr.SetBrush(gr.bDiagcross,gr.RGB(0,255,0));
  gr.Ellipse(50,50,150,150);
  gr.SetBrush(gr.bCross,gr.RGB(0,0,255));
  gr.Ellipse(90,90,150,150);

  gr.SetWindowTitle("   ...");
    gr.WaitForClick();
  gr.SetWindowTitle("");

  gr.FilledRect(0,0,gr.GetW(),gr.GetH(),0FFFFFFH);
  gr.SetSolidPen(1,gr.RGB(128,128,128));
  gr.SetBrush(gr.bSolid,gr.RGB(255,0,0));
  gr.RoundRect(10,10,28,32,4);
  gr.SetBrush(gr.bDiagcross,gr.RGB(0,255,0));
  gr.RoundRect(50,50,28,32,4);
  gr.SetBrush(gr.bCross,gr.RGB(0,0,255));
  gr.RoundRect(90,90,28,32,4);
  gr.OutlineRect(130,130,100,100,3,gr.RGB(255,0,0));
  gr.OutlineRect(170,170,100,100,3,gr.RGB(0,255,0));
  gr.OutlineRect(210,210,100,100,3,gr.RGB(0,0,255));

  gr.SetWindowTitle("   ...");
    gr.WaitForClick();
  gr.SetWindowTitle("");

  lines;

  printf("this is the end...\n");
END test.
